diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_lib.c openssl-1.0.0q/crypto/engine/eng_lib.c
--- openssl-1.0.0q.orig/crypto/engine/eng_lib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_lib.c	2017-04-25 16:23:40.248527673 +0200
@@ -56,6 +56,10 @@
  *
  */
 
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
 #include "eng_int.h"
 #include <openssl/rand.h>
 
@@ -71,13 +75,14 @@
 		ENGINEerr(ENGINE_F_ENGINE_NEW, ERR_R_MALLOC_FAILURE);
 		return NULL;
 		}
-	memset(ret, 0, sizeof(ENGINE));
+	op_memset(ret, 0, sizeof(ENGINE));
 	ret->struct_ref = 1;
 	engine_ref_debug(ret, 0, 1)
 	CRYPTO_new_ex_data(CRYPTO_EX_INDEX_ENGINE, ret, &ret->ex_data);
 	return ret;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 /* Placed here (close proximity to ENGINE_new) so that modifications to the
  * elements of the ENGINE structure are more likely to be caught and changed
  * here. */
@@ -101,6 +106,7 @@
 	e->cmd_defns = NULL;
 	e->flags = 0;
 	}
+#endif
 
 int engine_free_util(ENGINE *e, int locked)
 	{
@@ -148,7 +154,12 @@
  * cleanup can register a "cleanup" callback here. That way we don't get linker
  * bloat by referring to all *possible* cleanups, but any linker bloat into code
  * "X" will cause X's cleanup function to end up here. */
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(STACK_OF(ENGINE_CLEANUP_ITEM) *, cleanup_stack);
+#define cleanup_stack OPENSSL_GLOBAL_REF(cleanup_stack)
+#else
 static STACK_OF(ENGINE_CLEANUP_ITEM) *cleanup_stack = NULL;
+#endif
 static int int_cleanup_check(int create)
 	{
 	if(cleanup_stack) return 1;
@@ -164,6 +175,7 @@
 	item->cb = cb;
 	return item;
 	}
+#ifndef OPERA_SMALL_VERSION
 void engine_cleanup_add_first(ENGINE_CLEANUP_CB *cb)
 	{
 	ENGINE_CLEANUP_ITEM *item;
@@ -172,6 +184,7 @@
 	if(item)
 		sk_ENGINE_CLEANUP_ITEM_insert(cleanup_stack, item, 0);
 	}
+#endif
 void engine_cleanup_add_last(ENGINE_CLEANUP_CB *cb)
 	{
 	ENGINE_CLEANUP_ITEM *item;
@@ -194,13 +207,16 @@
 			engine_cleanup_cb_free);
 		cleanup_stack = NULL;
 		}
+#ifndef OPERA_SMALL_VERSION
 	/* FIXME: This should be handled (somehow) through RAND, eg. by it
 	 * registering a cleanup callback. */
 	RAND_set_rand_method(NULL);
+#endif
 	}
 
 /* Now the "ex_data" support */
 
+#ifndef OPERA_SMALL_VERSION
 int ENGINE_get_ex_new_index(long argl, void *argp, CRYPTO_EX_new *new_func,
 		CRYPTO_EX_dup *dup_func, CRYPTO_EX_free *free_func)
 	{
@@ -217,6 +233,7 @@
 	{
 	return(CRYPTO_get_ex_data(&e->ex_data, idx));
 	}
+#endif
 
 /* Functions to get/set an ENGINE's elements - mainly to avoid exposing the
  * ENGINE structure itself. */
@@ -245,6 +262,7 @@
 	return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ENGINE_set_destroy_function(ENGINE *e, ENGINE_GEN_INT_FUNC_PTR destroy_f)
 	{
 	e->destroy = destroy_f;
@@ -330,3 +348,6 @@
 	{
 	return &internal_static_hack;
 	}
+#endif /* #ifndef OPERA_SMALL_VERSION */
+
+#endif /* OPENSSL_NO_ENGINE */
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_list.c openssl-1.0.0q/crypto/engine/eng_list.c
--- openssl-1.0.0q.orig/crypto/engine/eng_list.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_list.c	2017-04-25 16:23:40.249528079 +0200
@@ -61,6 +61,10 @@
  * SUN MICROSYSTEMS, INC., and contributed to the OpenSSL project.
  */
 
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
 #include "eng_int.h"
 
 /* The linked-list of pointers to engine types. engine_list_head
@@ -73,8 +77,15 @@
  * engine_list_head, and each non-null "next" pointer account for
  * the list itself assuming exactly 1 structural reference on each
  * list member. */
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(ENGINE *, engine_list_head);
+#define engine_list_head OPENSSL_GLOBAL_REF(engine_list_head)
+OPENSSL_IMPLEMENT_GLOBAL(ENGINE *, engine_list_tail);
+#define engine_list_tail OPENSSL_GLOBAL_REF(engine_list_tail)
+#else
 static ENGINE *engine_list_head = NULL;
 static ENGINE *engine_list_tail = NULL;
+#endif
 
 /* This cleanup function is only needed internally. If it should be called, we
  * register it with the "ENGINE_cleanup()" stack to be called during cleanup. */
@@ -107,7 +118,7 @@
 	iterator = engine_list_head;
 	while(iterator && !conflict)
 		{
-		conflict = (strcmp(iterator->id, e->id) == 0);
+		conflict = (op_strcmp(iterator->id, e->id) == 0);
 		iterator = iterator->next;
 		}
 	if(conflict)
@@ -204,6 +215,7 @@
 	return ret;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 ENGINE *ENGINE_get_last(void)
 	{
 	ENGINE *ret;
@@ -218,6 +230,7 @@
 	CRYPTO_w_unlock(CRYPTO_LOCK_ENGINE);
 	return ret;
 	}
+#endif
 
 /* Iterate to the next/previous "ENGINE" type (NULL = end of the list). */
 ENGINE *ENGINE_get_next(ENGINE *e)
@@ -243,6 +256,7 @@
 	return ret;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 ENGINE *ENGINE_get_prev(ENGINE *e)
 	{
 	ENGINE *ret = NULL;
@@ -265,6 +279,7 @@
 	ENGINE_free(e);
 	return ret;
 	}
+#endif
 
 /* Add another "ENGINE" type into the list. */
 int ENGINE_add(ENGINE *e)
@@ -313,6 +328,7 @@
 	return to_return;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 static void engine_cpy(ENGINE *dest, const ENGINE *src)
 	{
 	dest->id = src->id;
@@ -350,7 +366,7 @@
 ENGINE *ENGINE_by_id(const char *id)
 	{
 	ENGINE *iterator;
-	char *load_dir = NULL;
+	const char *load_dir = NULL;
 	if(id == NULL)
 		{
 		ENGINEerr(ENGINE_F_ENGINE_BY_ID,
@@ -359,7 +375,7 @@
 		}
 	CRYPTO_w_lock(CRYPTO_LOCK_ENGINE);
 	iterator = engine_list_head;
-	while(iterator && (strcmp(id, iterator->id) != 0))
+	while(iterator && (op_strcmp(id, iterator->id) != 0))
 		iterator = iterator->next;
 	if(iterator)
 		{
@@ -389,7 +405,9 @@
 		{
 		ENGINEerr(ENGINE_F_ENGINE_BY_ID,
 			ENGINE_R_NO_SUCH_ENGINE);
+#ifndef OPERA_SMALL_VERSION
 		ERR_add_error_data(2, "id=", id);
+#endif
 		}
 	return iterator;
 #else
@@ -432,3 +450,6 @@
 	CRYPTO_add(&e->struct_ref,1,CRYPTO_LOCK_ENGINE);
 	return 1;
 	}
+#endif /* #ifndef OPERA_SMALL_VERSION */
+
+#endif /* OPENSSL_NO_ENGINE */
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_openssl.c openssl-1.0.0q/crypto/engine/eng_openssl.c
--- openssl-1.0.0q.orig/crypto/engine/eng_openssl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_openssl.c	2017-04-25 16:23:40.250527927 +0200
@@ -62,9 +62,13 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include <openssl/crypto.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
 #include <openssl/engine.h>
 #include <openssl/dso.h>
 #include <openssl/pem.h>
@@ -80,6 +84,7 @@
 #include <openssl/dh.h>
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 /* This testing gunk is implemented (and explained) lower down. It also assumes
  * the application explicitly calls "ENGINE_load_openssl()" because this is no
  * longer automatic in ENGINE_load_builtin_engines(). */
@@ -123,9 +128,11 @@
 	UI_METHOD *ui_method, void *callback_data);
 #endif
 
+#endif /* OPERA_SMALL_VERSION */
+
 /* The constants used when creating the ENGINE */
-static const char *engine_openssl_id = "openssl";
-static const char *engine_openssl_name = "Software engine support";
+#define engine_openssl_id "openssl"
+#define engine_openssl_name "Software engine support"
 
 /* This internal function is used by ENGINE_openssl() and possibly by the
  * "dynamic" ENGINE support too */
@@ -196,7 +203,7 @@
 #ifdef ENGINE_DYNAMIC_SUPPORT
 static int bind_fn(ENGINE *e, const char *id)
 	{
-	if(id && (strcmp(id, engine_openssl_id) != 0))
+	if(id && (op_strcmp(id, engine_openssl_id) != 0))
 		return 0;
 	if(!bind_helper(e))
 		return 0;
@@ -222,7 +229,7 @@
 static int test_cipher_nids[] = {NID_rc4,NID_rc4_40};
 static int test_cipher_nids_number = 2;
 typedef struct {
-	unsigned char key[TEST_RC4_KEY_SIZE];
+	unsigned char key[TEST_RC4_KEY_SIZE];  /* ARRAY OK UNUSED OPERA 2004-02-18 yngve */
 	RC4_KEY ks;
 	} TEST_RC4_KEY;
 #define test(ctx) ((TEST_RC4_KEY *)(ctx)->cipher_data)
@@ -232,7 +239,7 @@
 #ifdef TEST_ENG_OPENSSL_RC4_P_INIT
 	fprintf(stderr, "(TEST_ENG_OPENSSL_RC4) test_init_key() called\n");
 #endif
-	memcpy(&test(ctx)->key[0],key,EVP_CIPHER_CTX_key_length(ctx));
+	op_memcpy(&test(ctx)->key[0],key,EVP_CIPHER_CTX_key_length(ctx));
 	RC4_set_key(&test(ctx)->ks,EVP_CIPHER_CTX_key_length(ctx),
 		test(ctx)->key);
 	return 1;
@@ -382,3 +389,6 @@
 	return key;
 	}
 #endif
+
+
+#endif /* OPENSSL_NO_ENGINE */
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_pkey.c openssl-1.0.0q/crypto/engine/eng_pkey.c
--- openssl-1.0.0q.orig/crypto/engine/eng_pkey.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_pkey.c	2017-04-25 16:23:40.251527495 +0200
@@ -53,6 +53,7 @@
  *
  */
 
+#include <openssl/cryptlib.h>
 #include "eng_int.h"
 
 /* Basic get/set stuff */
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_table.c openssl-1.0.0q/crypto/engine/eng_table.c
--- openssl-1.0.0q.orig/crypto/engine/eng_table.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_table.c	2017-04-25 16:23:40.252528740 +0200
@@ -52,8 +52,12 @@
  *
  */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
+#include <openssl/engine.h>
 #include <openssl/lhash.h>
 #include "eng_int.h"
 
@@ -86,9 +90,18 @@
 	} ENGINE_PILE_DOALL;
 	
 
+/* This value stores global options controlling behaviour of (mostly) the
+ * engine_table_select() function. It's a bitmask of flag values of the form
+ * ENGINE_TABLE_FLAG_*** (as defined in engine.h) and is controlled by the
+ * ENGINE_[get|set]_table_flags() function. */
+#ifndef OPERA_SMALL_VERSION
 /* Global flags (ENGINE_TABLE_FLAG_***). */
 static unsigned int table_flags = 0;
+#else
+#define table_flags 0
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 /* API function manipulating 'table_flags' */
 unsigned int ENGINE_get_table_flags(void)
 	{
@@ -99,6 +112,7 @@
 	{
 	table_flags = flags;
 	}
+#endif
 
 /* Internal functions for the "piles" hash table */
 static unsigned long engine_pile_hash(const ENGINE_PILE *c)
@@ -127,6 +141,7 @@
 
 /* Privately exposed (via eng_int.h) functions for adding and/or removing
  * ENGINEs from the implementation table */
+#ifndef OPERA_SMALL_VERSION
 int engine_table_register(ENGINE_TABLE **table, ENGINE_CLEANUP_CB *cleanup,
 		ENGINE *e, const int *nids, int num_nids, int setdefault)
 	{
@@ -186,6 +201,7 @@
 	CRYPTO_w_unlock(CRYPTO_LOCK_ENGINE);
 	return ret;
 	}
+#endif
 static void int_unregister_cb_doall_arg(ENGINE_PILE *pile, ENGINE *e)
 	{
 	int n;
@@ -332,6 +348,8 @@
 	return ret;
 	}
 
+#endif /* OPENSSL_NO_ENGINE */
+
 /* Table enumeration */
 
 static void int_cb_doall_arg(ENGINE_PILE *pile, ENGINE_PILE_DOALL *dall)
diff -Naur openssl-1.0.0q.orig/crypto/engine/enginetest.c openssl-1.0.0q/crypto/engine/enginetest.c
--- openssl-1.0.0q.orig/crypto/engine/enginetest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/enginetest.c	2017-04-25 16:23:40.253527750 +0200
@@ -56,8 +56,13 @@
  *
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/e_os2.h>
 
 #ifdef OPENSSL_NO_ENGINE
@@ -106,7 +111,7 @@
 	ENGINE *new_h4 = NULL;
 
 	/* enable memory leak checking unless explicitly disabled */
-	if (!((getenv("OPENSSL_DEBUG_MEMORY") != NULL) && (0 == strcmp(getenv("OPENSSL_DEBUG_MEMORY"), "off"))))
+	if (!((getenv("OPENSSL_DEBUG_MEMORY") != NULL) && (0 == op_strcmp(getenv("OPENSSL_DEBUG_MEMORY"), "off"))))
 		{
 		CRYPTO_malloc_debug_init();
 		CRYPTO_set_mem_debug_options(V_CRYPTO_MDEBUG_ALL);
@@ -119,7 +124,7 @@
 	CRYPTO_mem_ctrl(CRYPTO_MEM_CHECK_ON);
 	ERR_load_crypto_strings();
 
-	memset(block, 0, 512 * sizeof(ENGINE *));
+	op_memset(block, 0, 512 * sizeof(ENGINE *));
 	if(((new_h1 = ENGINE_new()) == NULL) ||
 			!ENGINE_set_id(new_h1, "test_id0") ||
 			!ENGINE_set_name(new_h1, "First test item") ||
@@ -219,9 +224,9 @@
 	printf("About to beef up the engine-type list\n");
 	for(loop = 0; loop < 512; loop++)
 		{
-		sprintf(buf, "id%i", loop);
+		op_sprintf(buf, "id%i", loop);
 		id = BUF_strdup(buf);
-		sprintf(buf, "Fake engine type %i", loop);
+		op_sprintf(buf, "Fake engine type %i", loop);
 		name = BUF_strdup(buf);
 		if(((block[loop] = ENGINE_new()) == NULL) ||
 				!ENGINE_set_id(block[loop], id) ||
diff -Naur openssl-1.0.0q.orig/crypto/engine/tb_cipher.c openssl-1.0.0q/crypto/engine/tb_cipher.c
--- openssl-1.0.0q.orig/crypto/engine/tb_cipher.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/tb_cipher.c	2017-04-25 16:23:40.320320876 +0200
@@ -52,6 +52,14 @@
  *
  */
 
+#include <openssl/cryptlib.h>
+
+#include <openssl/evp.h>
+
+
+#ifndef OPENSSL_NO_ENGINE
+
+#include <openssl/engine.h>
 #include "eng_int.h"
 
 /* If this symbol is defined then ENGINE_get_cipher_engine(), the function that
@@ -59,6 +67,7 @@
  * brief debugging summaries to stderr with the 'nid'. */
 /* #define ENGINE_CIPHER_DEBUG */
 
+#ifndef OPERA_SMALL_VERSION
 static ENGINE_TABLE *cipher_table = NULL;
 
 void ENGINE_unregister_ciphers(ENGINE *e)
@@ -114,6 +123,7 @@
 	{
 	return engine_table_select(&cipher_table, nid);
 	}
+#endif
 
 /* Obtains a cipher implementation from an ENGINE functional reference */
 const EVP_CIPHER *ENGINE_get_cipher(ENGINE *e, int nid)
@@ -135,9 +145,13 @@
 	return e->ciphers;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 /* Sets the cipher callback in an ENGINE structure */
 int ENGINE_set_ciphers(ENGINE *e, ENGINE_CIPHERS_PTR f)
 	{
 	e->ciphers = f;
 	return 1;
 	}
+#endif
+
+#endif /* OPENSSL_NO_ENGINE */
diff -Naur openssl-1.0.0q.orig/crypto/engine/tb_dh.c openssl-1.0.0q/crypto/engine/tb_dh.c
--- openssl-1.0.0q.orig/crypto/engine/tb_dh.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/tb_dh.c	2017-04-25 16:23:40.321321561 +0200
@@ -52,6 +52,13 @@
  *
  */
 
+#ifndef OPENSSL_NO_DSA
+
+#include <openssl/evp.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
+#include <openssl/engine.h>
 #include "eng_int.h"
 
 /* If this symbol is defined then ENGINE_get_default_DH(), the function that is
@@ -62,6 +69,7 @@
 static ENGINE_TABLE *dh_table = NULL;
 static const int dummy_nid = 1;
 
+#ifndef OPERA_SMALL_VERSION
 void ENGINE_unregister_DH(ENGINE *e)
 	{
 	engine_table_unregister(&dh_table, e);
@@ -95,6 +103,7 @@
 				engine_unregister_all_DH, e, &dummy_nid, 1, 1);
 	return 1;
 	}
+#endif
 
 /* Exposed API function to get a functional reference from the implementation
  * table (ie. try to get a functional reference from the tabled structural
@@ -116,3 +125,7 @@
 	e->dh_meth = dh_meth;
 	return 1;
 	}
+
+
+#endif /* OPENSSL_NO_ENGINE */
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/engine/tb_digest.c openssl-1.0.0q/crypto/engine/tb_digest.c
--- openssl-1.0.0q.orig/crypto/engine/tb_digest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/tb_digest.c	2017-04-25 16:23:40.322321968 +0200
@@ -52,6 +52,13 @@
  *
  */
 
+#include <openssl/cryptlib.h>
+
+#include <openssl/evp.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
+#include <openssl/engine.h>
 #include "eng_int.h"
 
 /* If this symbol is defined then ENGINE_get_digest_engine(), the function that
@@ -59,6 +66,7 @@
  * brief debugging summaries to stderr with the 'nid'. */
 /* #define ENGINE_DIGEST_DEBUG */
 
+#ifndef OPERA_SMALL_VERSION
 static ENGINE_TABLE *digest_table = NULL;
 
 void ENGINE_unregister_digests(ENGINE *e)
@@ -114,6 +122,7 @@
 	{
 	return engine_table_select(&digest_table, nid);
 	}
+#endif
 
 /* Obtains a digest implementation from an ENGINE functional reference */
 const EVP_MD *ENGINE_get_digest(ENGINE *e, int nid)
@@ -141,3 +150,5 @@
 	e->digests = f;
 	return 1;
 	}
+
+#endif /* OPENSSL_NO_ENGINE */
diff -Naur openssl-1.0.0q.orig/crypto/engine/tb_dsa.c openssl-1.0.0q/crypto/engine/tb_dsa.c
--- openssl-1.0.0q.orig/crypto/engine/tb_dsa.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/tb_dsa.c	2017-04-25 16:23:40.322321968 +0200
@@ -52,6 +52,13 @@
  *
  */
 
+#ifndef OPENSSL_NO_DSA
+
+#ifndef OPENSSL_NO_ENGINE
+
+
+#include <openssl/evp.h>
+#include <openssl/engine.h>
 #include "eng_int.h"
 
 /* If this symbol is defined then ENGINE_get_default_DSA(), the function that is
@@ -62,6 +69,7 @@
 static ENGINE_TABLE *dsa_table = NULL;
 static const int dummy_nid = 1;
 
+#ifndef OPERA_SMALL_VERSION
 void ENGINE_unregister_DSA(ENGINE *e)
 	{
 	engine_table_unregister(&dsa_table, e);
@@ -95,6 +103,7 @@
 				engine_unregister_all_DSA, e, &dummy_nid, 1, 1);
 	return 1;
 	}
+#endif
 
 /* Exposed API function to get a functional reference from the implementation
  * table (ie. try to get a functional reference from the tabled structural
@@ -116,3 +125,8 @@
 	e->dsa_meth = dsa_meth;
 	return 1;
 	}
+
+
+#endif /* OPENSSL_NO_ENGINE */
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/engine/tb_rand.c openssl-1.0.0q/crypto/engine/tb_rand.c
--- openssl-1.0.0q.orig/crypto/engine/tb_rand.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/tb_rand.c	2017-04-25 16:23:40.323320978 +0200
@@ -52,6 +52,13 @@
  *
  */
 
+#include <openssl/cryptlib.h>
+
+#include <openssl/evp.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
+#include <openssl/engine.h>
 #include "eng_int.h"
 
 /* If this symbol is defined then ENGINE_get_default_RAND(), the function that is
@@ -59,6 +66,7 @@
  * display brief debugging summaries to stderr with the 'nid'. */
 /* #define ENGINE_RAND_DEBUG */
 
+#ifndef OPERA_SMALL_VERSION
 static ENGINE_TABLE *rand_table = NULL;
 static const int dummy_nid = 1;
 
@@ -103,6 +111,7 @@
 	{
 	return engine_table_select(&rand_table, dummy_nid);
 	}
+#endif
 
 /* Obtains an RAND implementation from an ENGINE functional reference */
 const RAND_METHOD *ENGINE_get_RAND(const ENGINE *e)
@@ -116,3 +125,5 @@
 	e->rand_meth = rand_meth;
 	return 1;
 	}
+
+#endif /* OPENSSL_NO_ENGINE */
diff -Naur openssl-1.0.0q.orig/crypto/engine/tb_rsa.c openssl-1.0.0q/crypto/engine/tb_rsa.c
--- openssl-1.0.0q.orig/crypto/engine/tb_rsa.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/tb_rsa.c	2017-04-25 16:23:40.324322501 +0200
@@ -52,6 +52,12 @@
  *
  */
 
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
+#include <openssl/evp.h>
+#include <openssl/engine.h>
 #include "eng_int.h"
 
 /* If this symbol is defined then ENGINE_get_default_RSA(), the function that is
@@ -59,6 +65,7 @@
  * display brief debugging summaries to stderr with the 'nid'. */
 /* #define ENGINE_RSA_DEBUG */
 
+#ifndef OPERA_SMALL_VERSION
 static ENGINE_TABLE *rsa_table = NULL;
 static const int dummy_nid = 1;
 
@@ -103,6 +110,7 @@
 	{
 	return engine_table_select(&rsa_table, dummy_nid);
 	}
+#endif
 
 /* Obtains an RSA implementation from an ENGINE functional reference */
 const RSA_METHOD *ENGINE_get_RSA(const ENGINE *e)
@@ -116,3 +124,5 @@
 	e->rsa_meth = rsa_meth;
 	return 1;
 	}
+
+#endif /* OPENSSL_NO_ENGINE */
diff -Naur openssl-1.0.0q.orig/crypto/err/.gitignore openssl-1.0.0q/crypto/err/.gitignore
--- openssl-1.0.0q.orig/crypto/err/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/err/.gitignore	2017-04-25 16:23:40.325321790 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/err/err.c openssl-1.0.0q/crypto/err/err.c
--- openssl-1.0.0q.orig/crypto/err/err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/err/err.c	2017-04-25 16:23:40.326322197 +0200
@@ -109,15 +109,20 @@
  *
  */
 
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdarg.h>
 #include <string.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/crypto.h>
 #include <openssl/buffer.h>
 #include <openssl/bio.h>
 #include <openssl/err.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 DECLARE_LHASH_OF(ERR_STRING_DATA);
 DECLARE_LHASH_OF(ERR_STATE);
@@ -222,7 +227,8 @@
 	};
 #endif
 
-
+// Declaration moved from err.c to err.h in order to be included into libopeay_constants.h.
+#ifndef OPERA_SMALL_VERSION
 /* Define the predeclared (but externally opaque) "ERR_FNS" type */
 struct st_ERR_FNS
 	{
@@ -241,6 +247,7 @@
 	/* Returns the next available error "library" numbers */
 	int (*cb_get_next_lib)(void);
 	};
+#endif // !OPERA_SMALL_VERSION
 
 /* Predeclarations of the "err_defaults" functions */
 static LHASH_OF(ERR_STRING_DATA) *int_err_get(int create);
@@ -254,24 +261,26 @@
 static ERR_STATE *int_thread_set_item(ERR_STATE *);
 static void int_thread_del_item(const ERR_STATE *);
 static int int_err_get_next_lib(void);
+
 /* The static ERR_FNS table using these defaults functions */
-static const ERR_FNS err_defaults =
-	{
-	int_err_get,
-	int_err_del,
-	int_err_get_item,
-	int_err_set_item,
-	int_err_del_item,
-	int_thread_get,
-	int_thread_release,
-	int_thread_get_item,
-	int_thread_set_item,
-	int_thread_del_item,
-	int_err_get_next_lib
-	};
+OPENSSL_PREFIX_CONST_ITEM(static, ERR_FNS, err__err_defaults, libopeay) \
+	CONST_ITEM_ENTRY_START( cb_err_get,            int_err_get) \
+	CONST_ITEM_ENTRY_SINGLE(cb_err_del,            int_err_del) \
+	CONST_ITEM_ENTRY_SINGLE(cb_err_get_item,       int_err_get_item) \
+	CONST_ITEM_ENTRY_SINGLE(cb_err_set_item,       int_err_set_item) \
+	CONST_ITEM_ENTRY_SINGLE(cb_err_del_item,       int_err_del_item) \
+	CONST_ITEM_ENTRY_SINGLE(cb_thread_get,         int_thread_get) \
+	CONST_ITEM_ENTRY_SINGLE(cb_thread_release,     int_thread_release) \
+	CONST_ITEM_ENTRY_SINGLE(cb_thread_get_item,    int_thread_get_item) \
+	CONST_ITEM_ENTRY_SINGLE(cb_thread_set_item,    int_thread_set_item) \
+	CONST_ITEM_ENTRY_SINGLE(cb_thread_del_item,    int_thread_del_item) \
+	CONST_ITEM_ENTRY_SINGLE(cb_get_next_lib,       int_err_get_next_lib) \
+CONST_ITEM_ENTRY_END
+#define err_defaults OPENSSL_GLOBAL_ITEM_NAME(err__err_defaults)
 
 /* The replacable table of ERR_FNS functions we use at run-time */
-static const ERR_FNS *err_fns = NULL;
+OPENSSL_IMPLEMENT_GLOBAL(const ERR_FNS *, err__err_fns);
+#define err_fns OPENSSL_GLOBAL_REF(err__err_fns)
 
 /* Eg. rather than using "err_get()", use "ERRFN(err_get)()". */
 #define ERRFN(a) err_fns->cb_##a
@@ -281,10 +290,17 @@
  * "err_defaults" functions. This way, a linked module can completely defer all
  * ERR state operation (together with requisite locking) to the implementations
  * and state in the loading application. */
-static LHASH_OF(ERR_STRING_DATA) *int_error_hash = NULL;
-static LHASH_OF(ERR_STATE) *int_thread_hash = NULL;
-static int int_thread_hash_references = 0;
-static int int_err_library_number= ERR_LIB_USER;
+OPENSSL_IMPLEMENT_GLOBAL(LHASH_OF(ERR_STRING_DATA) *, err__int_error_hash);
+#define int_error_hash OPENSSL_GLOBAL_REF(err__int_error_hash)
+
+OPENSSL_IMPLEMENT_GLOBAL(LHASH_OF(ERR_STATE) *, err__int_thread_hash);
+#define int_thread_hash OPENSSL_GLOBAL_REF(err__int_thread_hash)
+
+OPENSSL_IMPLEMENT_GLOBAL(int, err__int_thread_hash_references);
+#define int_thread_hash_references OPENSSL_GLOBAL_REF(err__int_thread_hash_references)
+
+OPENSSL_IMPLEMENT_GLOBAL(int, err__int_err_library_number);
+#define int_err_library_number OPENSSL_GLOBAL_REF(err__int_err_library_number)
 
 /* Internal function that checks whether "err_fns" is set and if not, sets it to
  * the defaults. */
@@ -632,6 +648,7 @@
 	(p)->err_data_flags[i]=0; \
 	} while(0)
 
+#ifndef OPENSSL_NO_ERR
 #define err_clear(p,i) \
 	do { \
 	(p)->err_flags[i]=0; \
@@ -640,6 +657,14 @@
 	(p)->err_file[i]=NULL; \
 	(p)->err_line[i]= -1; \
 	} while(0)
+#else
+#define err_clear(p,i) \
+	do { \
+	(p)->err_flags[i]=0; \
+	(p)->err_buffer[i]=0; \
+	err_clear_data(p,i); \
+	} while(0)
+#endif
 
 static void ERR_STATE_free(ERR_STATE *s)
 	{
@@ -714,7 +739,7 @@
 	 * This dirty hack strips them to something sensible.
 	 * @@@ We shouldn't modify a const string, though.
 	 */
-	if (strncmp(file,"*POSIX(", sizeof("*POSIX(")-1) == 0) {
+	if (op_strncmp(file,"*POSIX(", sizeof("*POSIX(")-1) == 0) {
 		char *end;
 
 		/* Skip the "*POSIX(" prefix */
@@ -723,7 +748,7 @@
 		if (*end == ')')
 			*end = '\0';
 		/* Optional: use the basename of the path only. */
-		if ((end = strrchr(file, '/')) != NULL)
+		if ((end = op_strrchr(file, '/')) != NULL)
 			file = &end[1];
 	}
 #endif
@@ -734,8 +759,10 @@
 		es->bottom=(es->bottom+1)%ERR_NUM_ERRORS;
 	es->err_flags[es->top]=0;
 	es->err_buffer[es->top]=ERR_PACK(lib,func,reason);
+#ifndef OPENSSL_NO_ERR
 	es->err_file[es->top]=file;
 	es->err_line[es->top]=line;
+#endif
 	err_clear_data(es,es->top);
 	}
 
@@ -757,6 +784,7 @@
 unsigned long ERR_get_error(void)
 	{ return(get_error_values(1,0,NULL,NULL,NULL,NULL)); }
 
+#ifndef OPERA_SMALL_VERSION
 unsigned long ERR_get_error_line(const char **file,
 	     int *line)
 	{ return(get_error_values(1,0,file,line,NULL,NULL)); }
@@ -764,11 +792,13 @@
 unsigned long ERR_get_error_line_data(const char **file, int *line,
 	     const char **data, int *flags)
 	{ return(get_error_values(1,0,file,line,data,flags)); }
+#endif
 
 
 unsigned long ERR_peek_error(void)
 	{ return(get_error_values(0,0,NULL,NULL,NULL,NULL)); }
 
+#ifndef OPERA_SMALL_VERSION
 unsigned long ERR_peek_error_line(const char **file, int *line)
 	{ return(get_error_values(0,0,file,line,NULL,NULL)); }
 
@@ -786,15 +816,25 @@
 unsigned long ERR_peek_last_error_line_data(const char **file, int *line,
 	     const char **data, int *flags)
 	{ return(get_error_values(0,1,file,line,data,flags)); }
+#endif
 
-
-static unsigned long get_error_values(int inc, int top, const char **file, int *line,
+static unsigned long get_error_values(int inc, int top, const char **fake_file, int *fake_line,
 	     const char **data, int *flags)
 	{	
 	int i=0;
 	ERR_STATE *es;
 	unsigned long ret;
 
+	// Opera local patch begin.
+	// Do not disclose filename and line number.
+	// Report fake values.
+	if (fake_file) *fake_file = "";
+	if (fake_line) *fake_line = 0;
+	// Create fake variables to fool the rest of the code in this function.
+	const char **file = NULL;
+	int *line = 0;
+	// Opera local patch end.
+
 	es=ERR_get_state();
 
 	if (inc && top)
@@ -820,6 +860,7 @@
 		es->err_buffer[i]=0;
 		}
 
+#ifndef OPENSSL_NO_ERR
 	if ((file != NULL) && (line != NULL))
 		{
 		if (es->err_file[i] == NULL)
@@ -833,6 +874,7 @@
 			if (line != NULL) *line=es->err_line[i];
 			}
 		}
+#endif
 
 	if (data == NULL)
 		{
@@ -872,15 +914,15 @@
 	rs=ERR_reason_error_string(e);
 
 	if (ls == NULL) 
-		BIO_snprintf(lsbuf, sizeof(lsbuf), "lib(%lu)", l);
+		op_snprintf(lsbuf, sizeof(lsbuf), "lib(%lu)", l);
 	if (fs == NULL)
-		BIO_snprintf(fsbuf, sizeof(fsbuf), "func(%lu)", f);
+		op_snprintf(fsbuf, sizeof(fsbuf), "func(%lu)", f);
 	if (rs == NULL)
-		BIO_snprintf(rsbuf, sizeof(rsbuf), "reason(%lu)", r);
+		op_snprintf(rsbuf, sizeof(rsbuf), "reason(%lu)", r);
 
-	BIO_snprintf(buf, len,"error:%08lX:%s:%s:%s", e, ls?ls:lsbuf, 
+	op_snprintf(buf, len,"error:%08lX:%s:%s:%s", e, ls?ls:lsbuf,
 		fs?fs:fsbuf, rs?rs:rsbuf);
-	if (strlen(buf) == len-1)
+	if (op_strlen(buf) == len-1)
 		{
 		/* output may be truncated; make sure we always have 5 
 		 * colon-separated fields, i.e. 4 colons ... */
@@ -892,7 +934,7 @@
 			
 			for (i = 0; i < NUM_COLONS; i++)
 				{
-				char *colon = strchr(s, ':');
+				char *colon = op_strchr(s, ':');
 				if (colon == NULL || colon > &buf[len-1] - NUM_COLONS + i)
 					{
 					/* set colon no. i at last possible position
@@ -1001,9 +1043,16 @@
 	}
 #endif
 
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(ERR_STATE, err__fallback);
+#define fallback OPENSSL_GLOBAL_REF(err__fallback)
+#endif
+
 ERR_STATE *ERR_get_state(void)
 	{
+#ifndef OPERA_SMALL_VERSION
 	static ERR_STATE fallback;
+#endif
 	ERR_STATE *ret,tmp,*tmpp=NULL;
 	int i;
 	CRYPTO_THREADID tid;
@@ -1041,11 +1090,13 @@
 	return ret;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ERR_get_next_error_library(void)
 	{
 	err_fns_check();
 	return ERRFN(get_next_lib)();
 	}
+#endif
 
 void ERR_set_error_data(char *data, int flags)
 	{
@@ -1070,7 +1121,7 @@
 	char *str,*p,*a;
 
 	s=80;
-	str=OPENSSL_malloc(s+1);
+	str= (char *) OPENSSL_malloc(s+1);
 	if (str == NULL) return;
 	str[0]='\0';
 
@@ -1082,11 +1133,11 @@
 		/* ignore NULLs, thanks to Bob Beck <beck@obtuse.com> */
 		if (a != NULL)
 			{
-			n+=strlen(a);
+			n+=op_strlen(a);
 			if (n > s)
 				{
 				s=n+20;
-				p=OPENSSL_realloc(str,s+1);
+				p= (char *) OPENSSL_realloc(str,s+1);
 				if (p == NULL)
 					{
 					OPENSSL_free(str);
@@ -1133,3 +1184,13 @@
 	es->err_flags[es->top]&=~ERR_FLAG_MARK;
 	return 1;
 	}
+
+#else // #if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+
+// Stubs for linking of the "minimal" profile without support for "complex globals".
+unsigned long ERR_get_error(void)  { return 0; }
+unsigned long ERR_peek_error(void) { return 0; }
+void ERR_clear_error(void) { return; }
+void ERR_remove_thread_state(const CRYPTO_THREADID *tid) { return; }
+
+#endif // #if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
diff -Naur openssl-1.0.0q.orig/crypto/err/err.h openssl-1.0.0q/crypto/err/err.h
--- openssl-1.0.0q.orig/crypto/err/err.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/err/err.h	2017-04-25 16:23:40.327322045 +0200
@@ -115,8 +115,10 @@
 #include <openssl/e_os2.h>
 
 #ifndef OPENSSL_NO_FP_API
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #include <openssl/ossl_typ.h>
@@ -137,7 +139,9 @@
 #define ERR_PUT_error(a,b,c,d,e)	ERR_put_error(a,b,c,NULL,0)
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #define ERR_TXT_MALLOCED	0x01
 #define ERR_TXT_STRING		0x02
@@ -152,8 +156,10 @@
 	unsigned long err_buffer[ERR_NUM_ERRORS];
 	char *err_data[ERR_NUM_ERRORS];
 	int err_data_flags[ERR_NUM_ERRORS];
+#ifndef OPENSSL_NO_ERR
 	const char *err_file[ERR_NUM_ERRORS];
 	int err_line[ERR_NUM_ERRORS];
+#endif
 	int top,bottom;
 	} ERR_STATE;
 
@@ -378,6 +384,28 @@
  * the application's "ERR_FNS". */
 int ERR_set_implementation(const ERR_FNS *fns);
 
+// Declaration moved from err.c to err.h in order to be included into libopeay_constants.h.
+#ifdef OPERA_SMALL_VERSION
+/* Define the predeclared (but externally opaque) "ERR_FNS" type */
+struct st_ERR_FNS
+	{
+	/* Works on the "error_hash" string table */
+	LHASH_OF(ERR_STRING_DATA) *(*cb_err_get)(int create);
+	void (*cb_err_del)(void);
+	ERR_STRING_DATA *(*cb_err_get_item)(const ERR_STRING_DATA *);
+	ERR_STRING_DATA *(*cb_err_set_item)(ERR_STRING_DATA *);
+	ERR_STRING_DATA *(*cb_err_del_item)(ERR_STRING_DATA *);
+	/* Works on the "thread_hash" error-state table */
+	LHASH_OF(ERR_STATE) *(*cb_thread_get)(int create);
+	void (*cb_thread_release)(LHASH_OF(ERR_STATE) **hash);
+	ERR_STATE *(*cb_thread_get_item)(const ERR_STATE *);
+	ERR_STATE *(*cb_thread_set_item)(ERR_STATE *);
+	void (*cb_thread_del_item)(const ERR_STATE *);
+	/* Returns the next available error "library" numbers */
+	int (*cb_get_next_lib)(void);
+	};
+#endif // OPERA_SMALL_VERSION
+
 #ifdef	__cplusplus
 }
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/err/err_all.c openssl-1.0.0q/crypto/err/err_all.c
--- openssl-1.0.0q.orig/crypto/err/err_all.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/err/err_all.c	2017-04-25 16:23:40.328322172 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1.h>
 #include <openssl/bn.h>
 #ifndef OPENSSL_NO_EC
